fetch_array = function(url, type) {
	return new Promise(function(resolve, reject) {
		fetch(url).then(function(response) {
			response.arrayBuffer().then(function(arraybuffer) {
				resolve(new type(arraybuffer))
			})
		})
	})
}

  Int32Array.fetch = function(url) { return fetch_array(url, Int32Array  ) }
Float32Array.fetch = function(url) { return fetch_array(url, Float32Array) }

// e.g.
// pc.Texture.fetch("./crowbar/triangles_0.jpg").then(_ => tex = _)
// or
// tex = await pc.Texture.fetch("./crowbar/triangles_0.jpg")
pc.Texture.fetch = function(url) {
	return new Promise(function(resolve, reject) {
		var image = new Image();
		image.crossOrigin = "anonymous";
		
		image.onload = function () {
			//console.log(this)
			var texture = new pc.Texture(app.graphicsDevice);
			texture.setSource(image);
			resolve(texture)
		};
		
		image.onerror = function (bla) {
			console.log("image.onerror", bla);
		};
		
		image.src = url;
	})
}

//ProceduralMesh = function(indices, positions, uvs) {
//	this.indices = undefined;
//	this.positions = undefined;
//	this.uvs = undefined;
//}
//ProceduralMesh.prototype = Object.create( pc.Mesh.prototype )

ProceduralMesh = function() {}

ProceduralMesh.fetch = function(name) {
	var downloads = [
		  Int32Array.fetch("./" + name + "/triangles_0.vec3"),
		Float32Array.fetch("./" + name + "/vertices_0/0.vec3"),
		Float32Array.fetch("./" + name + "/uvs_0.vec2"),
	]
	return new Promise(function(resolve, reject) {
		Promise.all(downloads).then(function(tmp) {
			var indices = tmp[0]
			var positions = tmp[1]
			var uvs = tmp[2]
			for (var i=0; i<positions.length; i++)
				positions[i] *= 100;
			//console.log(indices, positions, uvs)
			//console.log("Got all: ", tmp);
			resolve(mesh_from_buffers(indices, positions, uvs))
		})
	})
}